<template>
  <div class="MusicDiskTab _tabcontent">
    <client-only>
      <vue-drawer-layout
        :content-drawable="true"
        :reverse="false"
        :enable="isDrawerEnabled"
        :drawer-width="800"
        @slide-end="handleSlideEnd"
        @mask-click="closeDrawer"
        ref="drawer">
        <div class="DrawerContent" slot="drawer">
          <iframe
            :src="diskFrameSrc"
            ref="diskFrame"
            class="DiskFrame"
            nwdisable
            nwfaketop
            nwuseragent="Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36"
          />
        </div>
        <div slot="content">
          <tab-simple
            v-model="items"
            :is-tab-active="isTabActive"
            :item-title="'L: play/pause, R: add to playlist'"
            @leftClick="leftClick"
            @rightClick="rightClick"
            @middleClick="middleClick"
            @create="openDrawer"
            @onTabActive="onTabActive"
            tab-name="tracks"
            single-item="track">
            <template slot="controls" slot-scope="prop">
              <i
                @click="leftClick(prop.item)"
                v-if="prop.item.local && prop.item.name === player.trackName && player.play === false"
                class="fa fa-play"
                aria-hidden="true"/>
              <i
                @click="leftClick(prop.item)"
                v-if="prop.item.local && prop.item.name === player.trackName && player.play === true"
                class="fa fa-pause"
                aria-hidden="true"/>
              <i
                v-loading="prop.item.downloading"
                v-if="!prop.item.local || prop.item.downloading"
                @click="downloadTrack(prop.item, false)"
                class="fa fa-cloud-download"
                aria-hidden="true"
                title="download track"/>
              <i
                @click="deleteItem(prop.item)"
                class="fa fa-trash"
                aria-hidden="true"
                title="delete track"/>
            </template>
            <template slot="slider" slot-scope="prop">
              <el-slider
                v-if="prop.item.name === player.trackName"
                v-model="player.time"
                @change="playerChange"
                :max="Number(player.track.duration || 100)"
                :format-tooltip="formatTooltip">
              </el-slider>
            </template>
            <template slot="extra-buttons">
              <el-button
                ref="repeatButton"
                @click="toggleRepeat">
                {{ repeat }}
              </el-button>
              <el-button
                ref="shuffleButton"
                @click="shuffleItems">
                <i class="fa fa-random" aria-hidden="true"></i>
              </el-button>
            </template>
          </tab-simple>
        </div>
      </vue-drawer-layout>
    </client-only>
  </div>
</template>

<script>
import TabSimple from '@/components/ui/TabBar/TabSimple/TabSimple'

export default {
  components: {
    TabSimple
  },
  data() {
    return {
      items: [],
      shuffle: false,
      repeat: 'all',
      diskFrameSrc: '',
      isDrawerEnabled: false,
      isDrawerOpened: false,
      player: {
        track: null,
        interval: null,
        trackName: '',
        play: false,
        time: 0,
        duration: 100,
      }
    }
  },
  computed: {
    isTabActive() {
      return this.$parent.active
    },
  },
  mounted() {
    if (this.isTabActive) {
      this.onTabActive()
    }
    if (process.client) {
      window.ondragover = (e) => {
        e.preventDefault()
        return false
      }
      window.ondrop = (e) => {
        e.preventDefault()
        return false
      }
    }
  },
  watch: {
    isDrawerOpened(val) {
      if (!this.diskFrameSrc) {
        this.diskFrameSrc = 'https://disk.yandex.ru/client/disk/_Music'
      }
      if (!val) {
        this.checkUpdates()
      }
    }
  },
  methods: {
    shuffleItems() {
      this.items = _.shuffle(this.items)
    },
    toggleRepeat() {
      // ['single', 'all', 'once']
      if (this.repeat === 'single') {
        this.repeat = 'all'
        return
      }

      if (this.repeat === 'all') {
        this.repeat = 'once'
        return
      }

      if (this.repeat === 'once') {
        this.repeat = 'single'
        return
      }
    },
    async onTabActive(force) {
      if (!this.items.length || force) {
        const { data } = await this.$axios.get(`/music/disk/get`)
        this.items = data
        console.log('tracks', this.items)
      }
    },
    async checkUpdates() {
      const { data } = await this.$axios.get(`/music/disk/get`)
      const names = this.items.map(item => item.name)
      data.map(item => {
        !names.includes(item.name) && this.items.unshift(item)
      })
    },
    handleSlideEnd(visible) {
      this.isDrawerOpened = visible
    },
    openDrawer() {
      this.$refs.drawer.toggle(true)
      this.isDrawerOpened = true
    },
    closeDrawer() {
      this.$refs.drawer.toggle(false)
      this.isDrawerOpened = false
    },

    leftClick(item) {
      const trackPath = path.join(sourcesDir, 'music', 'tracks', `${item.name}`)
      const player = this.player

      if (!fs.existsSync(trackPath)) {
        this.downloadTrack(item, true)
        return
      }

      if (player.trackName !== item.name) {
        this.startTrack(item)
        return
      }

      if (player.trackName === item.name && player.play === true) {
        this.pauseTrack(item)
        return
      }

      if (player.trackName === item.name && player.play === false) {
        this.playPausedTrack(item)
        return
      }
    },
    startTrack(item) {
      console.log('start track', item)
      const trackPath = path.join(sourcesDir, 'music', 'tracks', `${item.name}`)
      this.player.time = 0
      this.player.track && this.player.track.pause()
      this.player.trackName = item.name
      this.player.track = new Audio(trackPath)
      this.player.track.onended = this.onTrackEnd
      clearInterval(this.player.interval)
      this.startCountdown()
      this.player.track.play()
      this.player.play = true
    },
    pauseTrack(item) {
      console.log('pause track', item)
      clearInterval(this.player.interval)
      this.player.track.pause()
      this.player.play = false
    },
    playPausedTrack(item) {
      console.log('play paused track', item)
      this.startCountdown()
      this.player.track.play()
      this.player.play = true
    },
    onTrackEnd() {
      if (this.repeat === 'single') {
        this.player.time = 0
        this.player.track.currentTime = 0
        this.player.track.play()
        return
      }

      if (this.repeat === 'all') {
        const index = _.findIndex(this.items, { name: this.player.trackName })
        const playIndex = index !== this.items.length - 1
          ? index + 1
          : 0
        this.leftClick(this.items[playIndex])
        return
      }

      this.player.time = 0
      this.player.track.currentTime = 0
      clearInterval(this.player.interval)
      this.player.track.pause()
      this.player.play = false
    },
    formatTooltip(val) {
      return moment.duration(val, 'seconds').format('hh:mm:ss', { trim: false })
    },
    playerChange(val) {
      this.player.track.currentTime = val
    },
    startCountdown() {
      this.player.interval = setInterval(() => {
        this.player.time = this.player.time + 1
      }, 1000)
    },
    readConfig() {
      return new Promise((resolve, reject) => {
        jsonfile.readFile(path.join(os.homedir(), 'one-punch-web', 'config.json'), (err, config) => {
          err && console.log(err)
          resolve(config)
        })
      })
    },
    async downloadTrack(item, play) {
      console.log('download track', item)
      const targetFile = path.join(os.homedir(), 'one-punch-web', 'sources', 'music', 'tracks', item.name)
      const index = _.findIndex(this.items, { name: item.name })
      this.items.splice(index, 1, { ...item, downloading: true })
      await this.diskConnect()
      this.$options.disk.downloadFile('./_Music/' + item.name, targetFile, (err) => {
        err && console.log(err)
        this.items.splice(index, 1, { ...item, local: true, downloading: false })
        if (play) {
          this.leftClick(item)
        }
      })
    },
    rightClick(item) {
      console.log('add to playlist')
    },
    middleClick(item) {

    },
    diskConnect(force) {
      return new Promise(async (resolve, reject) => {
        if (!this.$options.disk || force) {
          const config = await this.readConfig()
          this.$options.disk = new YandexDisk(config.yandexDisk.login, config.yandexDisk.password)
        }
        resolve()
      })
    },
    deleteItem(item) {
      this.$confirm(`Delete track ${item.name}. Continue?`, 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(async () => {
        await this.$axios.post(`/music/disk/delete/${item.name}`)
        const index = _.findIndex(this.items, { name: item.name })
        this.items.splice(index, 1)
      })
    },
  }
}
</script>

<style lang="less" scoped>
@import "./MusicDiskTab.less";
</style>
